From e60e3ec8c6e2c752543d1938619bde1171bbd40b Mon Sep 17 00:00:00 2001
From: Chih-Hung Hsieh <chh@google.com>
Date: Thu, 10 Sep 2015 11:44:09 -0700
Subject: [PATCH] For clang use Blocks instead of nested functions.

* Clang has Blocks like closures that can serve similar
  purpose as the nested functions in gnu99.
  Syntax of Blocks is similar to nested functions that
  *NESTED_FUNC macro can be used for the function/block
  declarations.
  See spec in http://clang.llvm.org/docs/BlockLanguageSpec.html
* Local variables used in a closure should have __BLOCK
  attribute unless they are constants.
* Formal parameters used in a closure should be copied
  to local variable and declared as __BLOCK.
* Cannot goto and jump over __BLOCK variables, so these
  variables have been moved to be declared before goto.
* Clang Blocks cannot copy an array to a closure,
  and gcc complains about unbounded stack usage from alloca.

Signed-off-by: Chih-Hung Hsieh <chh@google.com>
---
 backends/ChangeLog                   |   7 ++
 backends/aarch64_regs.c              |  10 +-
 backends/ia64_retval.c               |   6 +-
 lib/nested_func.h                    |  85 ++++++++++++++++
 libdw/ChangeLog                      |  13 +++
 libdw/cfi.c                          |  13 +--
 libdw/dwarf_entry_breakpoints.c      |  18 ++--
 libdw/dwarf_getscopevar.c            |   8 +-
 libdw/dwarf_getsrclines.c            |  60 ++++++-----
 libdw/libdw_visit_scopes.c           |  22 +++--
 libdwelf/ChangeLog                   |   6 ++
 libdwelf/dwelf_elf_gnu_build_id.c    |   7 +-
 libdwfl/ChangeLog                    |  37 +++++++
 libdwfl/argp-std.c                   |  13 ++-
 libdwfl/core-file.c                  |  28 +++---
 libdwfl/dwfl_module.c                |   7 +-
 libdwfl/dwfl_module_addrsym.c        |  55 ++++++-----
 libdwfl/dwfl_module_getdwarf.c       |  77 +++++++++------
 libdwfl/dwfl_module_getsrc_file.c    |  28 +++---
 libdwfl/dwfl_segment_report_module.c | 187 ++++++++++++++++++++---------------
 libdwfl/elf-from-memory.c            | 133 +++++++++++++------------
 libdwfl/frame_unwind.c               |  17 ++--
 libdwfl/gzip.c                       |  35 +++----
 libdwfl/link_map.c                   |  61 +++++++-----
 libdwfl/linux-kernel-modules.c       |  37 +++----
 libdwfl/linux-proc-maps.c            |  13 +--
 libdwfl/relocate.c                   |  41 ++++----
 libelf/ChangeLog                     |   7 ++
 libelf/elf32_updatefile.c            |   5 +-
 libelf/elf_begin.c                   |   5 +-
 src/ChangeLog                        |  21 ++++
 src/addr2line.c                      |  19 ++--
 src/ar.c                             |   7 +-
 src/arlib-argp.c                     |   5 +-
 src/elflint.c                        |  14 +--
 src/ld.c                             |   5 +-
 src/readelf.c                        |  48 +++++----
 src/strip.c                          |  74 +++++++-------
 src/unstrip.c                        |  40 ++++----
 39 files changed, 790 insertions(+), 484 deletions(-)
 create mode 100644 lib/nested_func.h

diff --git a/backends/ChangeLog b/backends/ChangeLog
index 2059d86..32e0e38 100644
--- a/backends/ChangeLog
+++ b/backends/ChangeLog
@@ -1,3 +1,10 @@
+2015-09-10  Chih-Hung Hsieh  <chh@google.com>
+
+	* aarch64_regs.c (aarch64_register_info): Use *NESTED_FUNC macro
+	for nested functions and __BLOCK macro for variables used inside
+	nested functions.
+	* ia64_retval.c (hfa_type): Likewise.
+
 2015-09-04  Chih-Hung Hsieh  <chh@google.com>
 
 	* aarch64_init.c (aarch64_init): Replace K&R function definition
diff --git a/backends/aarch64_regs.c b/backends/aarch64_regs.c
index 7a8a678..053c99e 100644
--- a/backends/aarch64_regs.c
+++ b/backends/aarch64_regs.c
@@ -37,6 +37,7 @@
 
 #define BACKEND aarch64_
 #include "libebl_CPU.h"
+#include "nested_func.h"
 
 ssize_t
 aarch64_register_info (Ebl *ebl __attribute__ ((unused)),
@@ -47,9 +48,10 @@ aarch64_register_info (Ebl *ebl __attribute__ ((unused)),
   if (name == NULL)
     return 128;
 
-  __attribute__ ((format (printf, 3, 4)))
-  ssize_t
-  regtype (const char *setname, int type, const char *fmt, ...)
+  NESTED_FUNC (__attribute__ ((format (printf, 3, 4))) ssize_t,
+               regtype,
+               (const char *, int, const char *, ...),
+               (const char *setname, int type, const char *fmt, ...))
   {
     *setnamep = setname;
     *typep = type;
@@ -62,7 +64,7 @@ aarch64_register_info (Ebl *ebl __attribute__ ((unused)),
     if (s < 0 || (unsigned) s >= namelen)
       return -1;
     return s + 1;
-  }
+  };
 
   *prefix = "";
   *bits = 64;
diff --git a/backends/ia64_retval.c b/backends/ia64_retval.c
index b5928c5..339f092 100644
--- a/backends/ia64_retval.c
+++ b/backends/ia64_retval.c
@@ -35,6 +35,7 @@
 
 #define BACKEND ia64_
 #include "libebl_CPU.h"
+#include "nested_func.h"
 
 
 /* r8, or pair r8, r9, or aggregate up to r8-r11.  */
@@ -100,14 +101,15 @@ hfa_type (Dwarf_Die *typedie, Dwarf_Word size,
      If we find a datum that's not the same FP type as the first datum, punt.
      If we count more than eight total homogeneous FP data, punt.  */
 
-  inline int hfa (const Dwarf_Op *loc, int nregs)
+  INLINE_NESTED_FUNC (int, hfa, (const Dwarf_Op *, int),
+                      (const Dwarf_Op *loc, int nregs))
     {
       if (fpregs_used == 0)
 	*locp = loc;
       else if (*locp != loc)
 	return 9;
       return fpregs_used + nregs;
-    }
+    };
 
   int tag = DWARF_TAG_OR_RETURN (typedie);
   switch (tag)
diff --git a/lib/nested_func.h b/lib/nested_func.h
new file mode 100644
index 0000000..be44a31
--- /dev/null
+++ b/lib/nested_func.h
@@ -0,0 +1,85 @@
+/* Copyright (C) 2015 Red Hat, Inc.
+   This file is part of elfutils.
+   Written by Chih-Hung Hsieh <chh@google.com>, 2015.
+
+   This file is free software; you can redistribute it and/or modify
+   it under the terms of either
+
+     * the GNU Lesser General Public License as published by the Free
+       Software Foundation; either version 3 of the License, or (at
+       your option) any later version
+
+   or
+
+     * the GNU General Public License as published by the Free
+       Software Foundation; either version 2 of the License, or (at
+       your option) any later version
+
+   or both in parallel, as here.
+
+   elfutils is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+
+   You should have received copies of the GNU General Public License and
+   the GNU Lesser General Public License along with this program.  If
+   not, see <http://www.gnu.org/licenses/>.  */
+
+#ifndef _NESTED_FUNC_H
+#define _NESTED_FUNC_H 1
+
+#if __clang__
+
+  #define __BLOCK __block
+
+  #define NESTED_FUNC(return_type, function_name, \
+                      arg_types, arg_types_and_names) \
+    return_type (^function_name) arg_types = \
+        ^ return_type arg_types_and_names
+
+  /* Clang does not like inline keyword before a block variable. */
+  #define INLINE_NESTED_FUNC(r, f, t, a) \
+    NESTED_FUNC (r, f, t, a)
+
+  #define INLINE_INTUSE_NESTED_FUNC(r, f, t, a) \
+    NESTED_FUNC (r, INTUSE(f), t, a)
+
+  /* Recrusive blocks need to be declared before used. */
+  #define RECURSIVE_NESTED_FUNC(return_type, function_name, \
+                      arg_types, arg_types_and_names) \
+    __BLOCK return_type (^function_name) arg_types; \
+    function_name = ^ return_type arg_types_and_names
+
+  #define INLINE_RECURSIVE_NESTED_FUNC(r, f, t, a) \
+    RECURSIVE_NESTED_FUNC (r, f, t, a)
+
+  #define INLINE_INTUSE_RECURSIVE_NESTED_FUNC(r, f, t, a) \
+    RECURSIVE_NESTED_FUNC (r, INTUSE(f), t, a)
+
+#else /* gcc nested function */
+
+  #define __BLOCK
+
+  #define NESTED_FUNC(return_type, function_name, \
+                      arg_types, arg_types_and_names) \
+    return_type function_name arg_types_and_names
+
+  #define INLINE_NESTED_FUNC(r, f, t, a) \
+    inline NESTED_FUNC (r, f, t, a)
+
+  #define INLINE_INTUSE_NESTED_FUNC(r, f, t, a) \
+    inline NESTED_FUNC (r, INTUSE(f), t, a)
+
+  #define RECURSIVE_NESTED_FUNC(r, f, t, a) \
+    NESTED_FUNC (r, f, t, a)
+
+  #define INLINE_RECURSIVE_NESTED_FUNC(r, f, t, a) \
+    inline RECURSIVE_NESTED_FUNC (r, f, t, a)
+
+  #define INLINE_INTUSE_RECURSIVE_NESTED_FUNC(r, f, t, a) \
+    INLINE_RECURSIVE_NESTED_FUNC (r, INTUSE(f), t, a)
+
+#endif
+
+#endif /* _NESTED_FUNC_H */
diff --git a/libdw/ChangeLog b/libdw/ChangeLog
index 13beefc..6366f69 100644
--- a/libdw/ChangeLog
+++ b/libdw/ChangeLog
@@ -1,3 +1,16 @@
+2015-09-10  Chih-Hung Hsieh  <chh@google.com>
+
+	* cfi.c (execute_cfi): Use *NESTED_FUNC macro
+	for nested functions and __BLOCK macro for variables used inside
+	nested functions.
+	* dwarf_entry_breakpoints.c (dwarf_entry_breakpoints): Likewise.
+	* dwarf_getscopevar.c (dwarf_getscopevar): Likewise.
+	* dwarf_getsrclines.c (read_srclines): Likewise.
+	__BLOCK variables cannot be jumpped over.
+	Their declarations are moved to the top of the enclosing function.
+	* dwarf_visit_scopes.c (may_have_scopes): Likewise.
+	(__libdw_visit_scopes): Likewise.
+
 2015-09-09  Chih-Hung Hsieh  <chh@google.com>
 
 	* dwarf_macro_getsrcfiles.c (dwarf_macro_getsrcfiles): Remove
diff --git a/libdw/cfi.c b/libdw/cfi.c
index 5a6f956..fccf2c5 100644
--- a/libdw/cfi.c
+++ b/libdw/cfi.c
@@ -34,6 +34,7 @@
 #include "../libebl/libebl.h"
 #include "cfi.h"
 #include "memory-access.h"
+#include "nested_func.h"
 #include "encoded-value.h"
 #include "system.h"
 #include <assert.h>
@@ -68,7 +69,7 @@ execute_cfi (Dwarf_CFI *cache,
   /* The caller should not give us anything out of range.  */
   assert (loc <= find_pc);
 
-  int result = DWARF_E_NOERROR;
+  __BLOCK int result = DWARF_E_NOERROR;
 
 #define cfi_assert(ok) do {						      \
     if (likely (ok)) break;						      \
@@ -76,8 +77,8 @@ execute_cfi (Dwarf_CFI *cache,
     goto out;								      \
   } while (0)
 
-  Dwarf_Frame *fs = *state;
-  inline bool enough_registers (Dwarf_Word reg)
+  __BLOCK Dwarf_Frame *fs = *state;
+  INLINE_NESTED_FUNC (bool, enough_registers, (Dwarf_Word), (Dwarf_Word reg))
     {
       /* Don't allow insanely large register numbers.  268435456 registers
 	 should be enough for anybody.  And very large values might overflow
@@ -107,13 +108,13 @@ execute_cfi (Dwarf_CFI *cache,
 	    }
 	}
       return true;
-    }
+    };
 
-  inline void require_cfa_offset (void)
+  INLINE_NESTED_FUNC (void, require_cfa_offset, (void), (void))
   {
     if (unlikely (fs->cfa_rule != cfa_offset))
       fs->cfa_rule = cfa_invalid;
-  }
+  };
 
 #define register_rule(regno, r_rule, r_value) do {	\
     if (unlikely (! enough_registers (regno)))		\
diff --git a/libdw/dwarf_entry_breakpoints.c b/libdw/dwarf_entry_breakpoints.c
index ffd5169..65484ce 100644
--- a/libdw/dwarf_entry_breakpoints.c
+++ b/libdw/dwarf_entry_breakpoints.c
@@ -30,6 +30,7 @@
 # include <config.h>
 #endif
 #include "libdwP.h"
+#include "nested_func.h"
 #include <dwarf.h>
 #include <stdlib.h>
 
@@ -39,11 +40,11 @@ dwarf_entry_breakpoints (die, bkpts)
      Dwarf_Die *die;
      Dwarf_Addr **bkpts;
 {
-  int nbkpts = 0;
+  __BLOCK int nbkpts = 0;
   *bkpts = NULL;
 
   /* Add one breakpoint location to the result vector.  */
-  inline int add_bkpt (Dwarf_Addr pc)
+  INLINE_NESTED_FUNC (int, add_bkpt, (Dwarf_Addr), (Dwarf_Addr pc))
     {
       Dwarf_Addr *newlist = realloc (*bkpts, ++nbkpts * sizeof newlist[0]);
       if (newlist == NULL)
@@ -56,14 +57,14 @@ dwarf_entry_breakpoints (die, bkpts)
       newlist[nbkpts - 1] = pc;
       *bkpts = newlist;
       return nbkpts;
-    }
+    };
 
   /* Fallback result, break at the entrypc/lowpc value.  */
-  inline int entrypc_bkpt (void)
+  INLINE_NESTED_FUNC (int, entrypc_bkpt, (void), (void))
     {
       Dwarf_Addr pc;
       return INTUSE(dwarf_entrypc) (die, &pc) < 0 ? -1 : add_bkpt (pc);
-    }
+    };
 
   /* Fetch the CU's line records to look for this DIE's addresses.  */
   Dwarf_Die cudie = CUDIE (die->cu);
@@ -81,8 +82,9 @@ dwarf_entry_breakpoints (die, bkpts)
   /* Search a contiguous PC range for prologue-end markers.
      If DWARF, look for proper markers.
      Failing that, if ADHOC, look for the ad hoc convention.  */
-  inline int search_range (Dwarf_Addr low, Dwarf_Addr high,
-			   bool dwarf, bool adhoc)
+  INLINE_NESTED_FUNC (int, search_range,
+                      (Dwarf_Addr, Dwarf_Addr, bool, bool),
+                      (Dwarf_Addr low, Dwarf_Addr high, bool dwarf, bool adhoc))
     {
       size_t l = 0, u = nlines;
       while (l < u)
@@ -115,7 +117,7 @@ dwarf_entry_breakpoints (die, bkpts)
 	}
       __libdw_seterrno (DWARF_E_INVALID_DWARF);
       return -1;
-    }
+    };
 
   /* Search each contiguous address range for DWARF prologue_end markers.  */
 
diff --git a/libdw/dwarf_getscopevar.c b/libdw/dwarf_getscopevar.c
index eb50c0a..73c9475 100644
--- a/libdw/dwarf_getscopevar.c
+++ b/libdw/dwarf_getscopevar.c
@@ -33,6 +33,7 @@
 #include <stdbool.h>
 #include <string.h>
 #include "libdwP.h"
+#include "nested_func.h"
 #include <dwarf.h>
 
 
@@ -70,9 +71,10 @@ dwarf_getscopevar (Dwarf_Die *scopes, int nscopes,
 {
   /* Match against the given file name.  */
   size_t match_file_len = match_file == NULL ? 0 : strlen (match_file);
-  bool lastfile_matches = false;
+  __BLOCK bool lastfile_matches = false;
   const char *lastfile = NULL;
-  inline bool file_matches (Dwarf_Files *files, size_t idx)
+  INLINE_NESTED_FUNC (bool, file_matches,
+                      (Dwarf_Files *, size_t), (Dwarf_Files *files, size_t idx))
     {
       if (idx >= files->nfiles)
 	return false;
@@ -87,7 +89,7 @@ dwarf_getscopevar (Dwarf_Die *scopes, int nscopes,
 				  || file[len - match_file_len - 1] == '/'));
 	}
       return lastfile_matches;
-    }
+    };
 
   /* Start with the innermost scope and move out.  */
   for (int out = 0; out < nscopes; ++out)
diff --git a/libdw/dwarf_getsrclines.c b/libdw/dwarf_getsrclines.c
index 389c824..f200d70 100644
--- a/libdw/dwarf_getsrclines.c
+++ b/libdw/dwarf_getsrclines.c
@@ -38,6 +38,7 @@
 
 #include "dwarf.h"
 #include "libdwP.h"
+#include "nested_func.h"
 
 
 struct filelist
@@ -86,10 +87,29 @@ read_srclines (Dwarf *dbg,
 {
   int res = -1;
 
-  struct linelist *linelist = NULL;
-  size_t nlinelist = 0;
-  size_t nfilelist = 0;
-  unsigned int ndirlist = 0;
+  __BLOCK struct linelist *linelist = NULL;
+  __BLOCK size_t nlinelist = 0;
+  __BLOCK size_t nfilelist = 0;
+  __BLOCK unsigned int ndirlist = 0;
+  /* We are about to process the statement program.  Initialize the
+     state machine registers (see 6.2.2 in the v2.1 specification).  */
+  __BLOCK Dwarf_Word addr = 0;
+  __BLOCK unsigned int op_index = 0;
+  __BLOCK unsigned int file = 1;
+  /* We only store an int, but want to check for overflow (see SET below).  */
+  __BLOCK int64_t line = 1;
+  __BLOCK unsigned int column = 0;
+  __BLOCK uint_fast8_t is_stmt = 0;
+  __BLOCK bool basic_block = false;
+  __BLOCK bool prologue_end = false;
+  __BLOCK bool epilogue_begin = false;
+  __BLOCK unsigned int isa = 0;
+  __BLOCK unsigned int discriminator = 0;
+  /* Next the minimum instruction length.  */
+  __BLOCK uint_fast8_t minimum_instr_len = 0;
+  /* Next the maximum operations per instruction, in version 4 format.  */
+  __BLOCK uint_fast8_t max_ops_per_instr = 1;
+
 
   struct filelist null_file =
     {
@@ -159,10 +179,8 @@ read_srclines (Dwarf *dbg,
   const unsigned char *header_start = linep;
 
   /* Next the minimum instruction length.  */
-  uint_fast8_t minimum_instr_len = *linep++;
+  minimum_instr_len = *linep++;
 
-  /* Next the maximum operations per instruction, in version 4 format.  */
-  uint_fast8_t max_ops_per_instr = 1;
   if (version >= 4)
     {
       if (unlikely (lineendp - linep < 5))
@@ -176,6 +194,8 @@ read_srclines (Dwarf *dbg,
      register.  */
   uint_fast8_t default_is_stmt = *linep++;
 
+  is_stmt = default_is_stmt;
+
   /* Now the line base.  */
   int_fast8_t line_base = (int8_t) *linep++;
 
@@ -321,29 +341,15 @@ read_srclines (Dwarf *dbg,
       goto out;
     }
 
-  /* We are about to process the statement program.  Initialize the
-     state machine registers (see 6.2.2 in the v2.1 specification).  */
-  Dwarf_Word addr = 0;
-  unsigned int op_index = 0;
-  unsigned int file = 1;
-  /* We only store an int, but want to check for overflow (see SET below).  */
-  int64_t line = 1;
-  unsigned int column = 0;
-  uint_fast8_t is_stmt = default_is_stmt;
-  bool basic_block = false;
-  bool prologue_end = false;
-  bool epilogue_begin = false;
-  unsigned int isa = 0;
-  unsigned int discriminator = 0;
-
   /* Apply the "operation advance" from a special opcode or
      DW_LNS_advance_pc (as per DWARF4 6.2.5.1).  */
-  inline void advance_pc (unsigned int op_advance)
+  INLINE_NESTED_FUNC (void, advance_pc,
+                      (unsigned int), (unsigned int op_advance))
   {
     addr += minimum_instr_len * ((op_index + op_advance)
 				 / max_ops_per_instr);
     op_index = (op_index + op_advance) % max_ops_per_instr;
-  }
+  };
 
   /* Process the instructions.  */
 
@@ -361,7 +367,9 @@ read_srclines (Dwarf *dbg,
       goto invalid_data;						\
   } while (0)
 
-  inline bool add_new_line (struct linelist *new_line, bool end_sequence)
+  INLINE_NESTED_FUNC (bool, add_new_line,
+                      (struct linelist *, bool),
+                      (struct linelist *new_line, bool end_sequence))
   {
     new_line->next = linelist;
     new_line->sequence = nlinelist;
@@ -395,7 +403,7 @@ read_srclines (Dwarf *dbg,
 #undef SET
 
     return false;
-  }
+  };
 
   while (linep < lineendp)
     {
diff --git a/libdw/libdw_visit_scopes.c b/libdw/libdw_visit_scopes.c
index d0b5134..06895b4 100644
--- a/libdw/libdw_visit_scopes.c
+++ b/libdw/libdw_visit_scopes.c
@@ -31,6 +31,7 @@
 #endif
 
 #include "libdwP.h"
+#include "nested_func.h"
 #include <dwarf.h>
 
 
@@ -65,29 +66,30 @@ may_have_scopes (Dwarf_Die *die)
 }
 
 int
-__libdw_visit_scopes (depth, root, imports, previsit, postvisit, arg)
+__libdw_visit_scopes (depth, root, imports_param, previsit, postvisit, arg)
      unsigned int depth;
      struct Dwarf_Die_Chain *root;
-     struct Dwarf_Die_Chain *imports;
+     struct Dwarf_Die_Chain *imports_param;
      int (*previsit) (unsigned int depth, struct Dwarf_Die_Chain *, void *);
      int (*postvisit) (unsigned int depth, struct Dwarf_Die_Chain *, void *);
      void *arg;
 {
-  struct Dwarf_Die_Chain child;
-  int ret;
+  __BLOCK struct Dwarf_Die_Chain child;
+  __BLOCK int ret;
+  __BLOCK struct Dwarf_Die_Chain *imports = imports_param;
 
   child.parent = root;
   if ((ret = INTUSE(dwarf_child) (&root->die, &child.die)) != 0)
     return ret < 0 ? -1 : 0; // Having zero children is legal.
 
-  inline int recurse (void)
+  INLINE_NESTED_FUNC (int, recurse, (void), (void))
     {
       return __libdw_visit_scopes (depth + 1, &child, imports,
 				   previsit, postvisit, arg);
-    }
+    };
 
   /* Checks the given DIE hasn't been imported yet to prevent cycles.  */
-  inline bool imports_contains (Dwarf_Die *die)
+  INLINE_NESTED_FUNC (bool, imports_contains, (Dwarf_Die *), (Dwarf_Die *die))
   {
     for (struct Dwarf_Die_Chain *import = imports; import != NULL;
 	 import = import->parent)
@@ -95,9 +97,9 @@ __libdw_visit_scopes (depth, root, imports, previsit, postvisit, arg)
 	return true;
 
     return false;
-  }
+  };
 
-  inline int walk_children ()
+  INLINE_RECURSIVE_NESTED_FUNC (int, walk_children, (void), (void))
   {
     do
       {
@@ -161,7 +163,7 @@ __libdw_visit_scopes (depth, root, imports, previsit, postvisit, arg)
     while ((ret = INTUSE(dwarf_siblingof) (&child.die, &child.die)) == 0);
 
     return ret < 0 ? -1 : 0;
-  }
+  };
 
   return walk_children ();
 }
diff --git a/libdwelf/ChangeLog b/libdwelf/ChangeLog
index 342cb9c..cc7a47f 100644
--- a/libdwelf/ChangeLog
+++ b/libdwelf/ChangeLog
@@ -1,3 +1,9 @@
+2015-09-10  Chih-Hung Hsieh  <chh@google.com>
+
+	* dwelf_elf_gnu_build_id.c (find_elf_build_id): Use *NESTED_FUNC macro
+	for nested functions and __BLOCK macro for variables used inside
+	nested functions.
+
 2014-11-14  Mark Wielaard  <mjw@redhat.com>
 
 	* dwelf_elf_gnu_debuglink.c (dwelf_elf_gnu_debuglink): Check d_buf
diff --git a/libdwelf/dwelf_elf_gnu_build_id.c b/libdwelf/dwelf_elf_gnu_build_id.c
index 1ed501d..8aff36b 100644
--- a/libdwelf/dwelf_elf_gnu_build_id.c
+++ b/libdwelf/dwelf_elf_gnu_build_id.c
@@ -32,6 +32,7 @@
 
 #include "libdwelfP.h"
 #include "libdwflP.h"
+#include "nested_func.h"
 
 #define NO_VADDR	((GElf_Addr) -1l)
 
@@ -42,7 +43,9 @@ find_elf_build_id (Dwfl_Module *mod, int e_type, Elf *elf,
 		   const void **build_id_bits, GElf_Addr *build_id_elfaddr,
 		   int *build_id_len)
 {
-  int check_notes (Elf_Data *data, GElf_Addr data_elfaddr)
+  NESTED_FUNC (int, check_notes,
+               (Elf_Data *, GElf_Addr),
+               (Elf_Data *data, GElf_Addr data_elfaddr))
   {
     size_t pos = 0;
     GElf_Nhdr nhdr;
@@ -60,7 +63,7 @@ find_elf_build_id (Dwfl_Module *mod, int e_type, Elf *elf,
 	  return 1;
 	}
     return 0;
-  }
+  };
 
   size_t shstrndx = SHN_UNDEF;
   int result = 0;
diff --git a/libdwfl/ChangeLog b/libdwfl/ChangeLog
index 03404e9..8dd29b2 100644
--- a/libdwfl/ChangeLog
+++ b/libdwfl/ChangeLog
@@ -1,3 +1,40 @@
+2015-09-10  Chih-Hung Hsieh  <chh@google.com>
+
+	* argp-std.c (parse_opt): Use *NESTED_FUNC macro
+	for nested functions and __BLOCK macro for variables used inside
+	nested functions.
+	* core-file.c (elf_begin_rand): Likewise.
+	(core_file_read_eagerly): Likewise.
+	Parameters used in a nested function are copied to local
+	__BLOCK variable for nested functions.
+	(dwfl_elf_phdr_memory_callback): Likewise.
+	* dwfl_module.c (dwfl_report_module): Likewise.
+	* dwfl_module_addrsym.c (__libdwfl_addrsym): Likewise.
+	* dwfl_module_getdwarf.c (find_prelink_address_sync): Likewise.
+	(find_offsets): Likewise.
+	(find_dynsym): Likewise, change local array to pointer variable
+	to be used inside a clang Block.
+	* dwfl_module_getsrc_file.c (dwfl_module_getsrc_file): Likewise.
+	* dwfl_segment_report_module.c (invalid_elf): Likewise.
+	(dwfl_segment_report_module): Likewise, copy parameter to local
+	__BLOCK variable to be used inside clang Blocks.
+	* elf-from-memory.c (elf_from_remote_memory): Likewise.
+	Clang Blocks cannot be nested inside switches like existing code;
+	move two handle_segment functions out of the swtich statements and
+	rename them to handle_segment1 and handle_segment2.
+	* frame_unwind.c (expr_eval): Likewise.
+	* gzip.c (unzip): Likewise.
+	* link_map.c (auxv_format_probe): Likewise.
+	(report_r_debug): Likewise, change array to pointer __BLOCK variable
+	for clang nested Blocks.
+	(dwfl_link_map_report): Likewise.
+	* linux-kernel-modules.c (intuit_kernel_bounds): Likewise.
+	(check_module_notes): Likewise.
+	(dwfl_linux_kernel_find_elf): Likewise.
+	* linux-proc-maps.c (grovel_auxv): Likewise.
+	(proc_maps_report): Likewise.
+	* relocate.c (relocate_section): Likewise.
+
 2015-09-10  Chih-Hung Hsieh <chh@google.com>
 
 	* dwfl_module_getdwarf.c (find_prelink_address_sync): Do not use
diff --git a/libdwfl/argp-std.c b/libdwfl/argp-std.c
index 42b7e78..06ba3b6 100644
--- a/libdwfl/argp-std.c
+++ b/libdwfl/argp-std.c
@@ -27,6 +27,7 @@
    not, see <http://www.gnu.org/licenses/>.  */
 
 #include "libdwflP.h"
+#include "nested_func.h"
 #include <argp.h>
 #include <stdlib.h>
 #include <assert.h>
@@ -103,7 +104,9 @@ struct parse_opt
 static error_t
 parse_opt (int key, char *arg, struct argp_state *state)
 {
-  inline void failure (Dwfl *dwfl, int errnum, const char *msg)
+  INLINE_NESTED_FUNC (void, failure,
+                      (Dwfl *, int, const char *),
+                      (Dwfl *dwfl, int errnum, const char *msg))
     {
       if (dwfl != NULL)
 	dwfl_end (dwfl);
@@ -112,12 +115,14 @@ parse_opt (int key, char *arg, struct argp_state *state)
 		      msg, INTUSE(dwfl_errmsg) (-1));
       else
 	argp_failure (state, EXIT_FAILURE, errnum, "%s", msg);
-    }
-  inline error_t fail (Dwfl *dwfl, int errnum, const char *msg)
+    };
+  INLINE_NESTED_FUNC (error_t, fail,
+                      (Dwfl *, int , const char *),
+                      (Dwfl *dwfl, int errnum, const char *msg))
     {
       failure (dwfl, errnum, msg);
       return errnum == -1 ? EIO : errnum;
-    }
+    };
 
   switch (key)
     {
diff --git a/libdwfl/core-file.c b/libdwfl/core-file.c
index bbe0899..ad94035 100644
--- a/libdwfl/core-file.c
+++ b/libdwfl/core-file.c
@@ -37,6 +37,7 @@
 #include <endian.h>
 #include <byteswap.h>
 #include "system.h"
+#include "nested_func.h"
 
 
 /* This is a prototype of what a new libelf interface might be.
@@ -49,14 +50,14 @@ elf_begin_rand (Elf *parent, loff_t offset, loff_t size, loff_t *next)
     return NULL;
 
   /* On failure return, we update *NEXT to point back at OFFSET.  */
-  inline Elf *fail (int error)
+  INLINE_NESTED_FUNC (Elf *, fail, (int), (int error))
   {
     if (next != NULL)
       *next = offset;
     //__libelf_seterrno (error);
     __libdwfl_seterrno (DWFL_E (LIBELF, error));
     return NULL;
-  }
+  };
 
   loff_t min = (parent->kind == ELF_K_ELF ?
 		(parent->class == ELFCLASS32
@@ -239,13 +240,14 @@ core_file_read_eagerly (Dwfl_Module *mod,
 }
 
 bool
-dwfl_elf_phdr_memory_callback (Dwfl *dwfl, int ndx,
+dwfl_elf_phdr_memory_callback (Dwfl *dwfl, int ndx_parameter,
 			       void **buffer, size_t *buffer_available,
 			       GElf_Addr vaddr,
 			       size_t minread,
 			       void *arg)
 {
-  Elf *elf = arg;
+  __BLOCK int ndx = ndx_parameter;
+  __BLOCK Elf *elf = arg;
 
   if (ndx == -1)
     {
@@ -258,7 +260,7 @@ dwfl_elf_phdr_memory_callback (Dwfl *dwfl, int ndx,
     }
 
   const GElf_Off align = dwfl->segment_align ?: 1;
-  GElf_Phdr phdr;
+  __BLOCK GElf_Phdr phdr;
 
   do
     if (unlikely (gelf_getphdr (elf, ndx++, &phdr) == NULL))
@@ -266,20 +268,20 @@ dwfl_elf_phdr_memory_callback (Dwfl *dwfl, int ndx,
   while (phdr.p_type != PT_LOAD
 	 || ((phdr.p_vaddr + phdr.p_memsz + align - 1) & -align) <= vaddr);
 
-  GElf_Off start = vaddr - phdr.p_vaddr + phdr.p_offset;
-  GElf_Off end;
-  GElf_Addr end_vaddr;
+  __BLOCK GElf_Off start = vaddr - phdr.p_vaddr + phdr.p_offset;
+  __BLOCK GElf_Off end;
+  __BLOCK GElf_Addr end_vaddr;
 
-  inline void update_end ()
+  INLINE_NESTED_FUNC (void, update_end, (void), (void))
   {
     end = (phdr.p_offset + phdr.p_filesz + align - 1) & -align;
     end_vaddr = (phdr.p_vaddr + phdr.p_memsz + align - 1) & -align;
-  }
+  };
 
   update_end ();
 
   /* Use following contiguous segments to get towards SIZE.  */
-  inline bool more (size_t size)
+  INLINE_NESTED_FUNC (bool, more, (size_t), (size_t size))
   {
     while (end <= start || end - start < size)
       {
@@ -287,7 +289,7 @@ dwfl_elf_phdr_memory_callback (Dwfl *dwfl, int ndx,
 	  /* This segment is truncated, so no following one helps us.  */
 	  return false;
 
-	if (unlikely (gelf_getphdr (elf, ndx++, &phdr) == NULL))
+	if (unlikely (gelf_getphdr (elf, ndx++, (Elf64_Phdr *) &phdr) == NULL))
 	  return false;
 
 	if (phdr.p_type == PT_LOAD)
@@ -301,7 +303,7 @@ dwfl_elf_phdr_memory_callback (Dwfl *dwfl, int ndx,
 	  }
       }
     return true;
-  }
+  };
 
   /* We need at least this much.  */
   if (! more (minread))
diff --git a/libdwfl/dwfl_module.c b/libdwfl/dwfl_module.c
index 8efcfaa..7035a89 100644
--- a/libdwfl/dwfl_module.c
+++ b/libdwfl/dwfl_module.c
@@ -27,6 +27,7 @@
    not, see <http://www.gnu.org/licenses/>.  */
 
 #include "libdwflP.h"
+#include "nested_func.h"
 #include <search.h>
 #include <unistd.h>
 
@@ -132,9 +133,9 @@ Dwfl_Module *
 dwfl_report_module (Dwfl *dwfl, const char *name,
 		    GElf_Addr start, GElf_Addr end)
 {
-  Dwfl_Module **tailp = &dwfl->modulelist, **prevp = tailp;
+  __BLOCK Dwfl_Module **tailp = &dwfl->modulelist, **prevp = tailp;
 
-  inline Dwfl_Module *use (Dwfl_Module *mod)
+  INLINE_NESTED_FUNC (Dwfl_Module *, use, (Dwfl_Module *), (Dwfl_Module *mod))
   {
     mod->next = *tailp;
     *tailp = mod;
@@ -146,7 +147,7 @@ dwfl_report_module (Dwfl *dwfl, const char *name,
       }
 
     return mod;
-  }
+  };
 
   for (Dwfl_Module *m = *prevp; m != NULL; m = *(prevp = &m->next))
     {
